﻿using AddinExamplesGeneral;
using System;
using System.ComponentModel.Composition;
using System.Threading.Tasks;
using Toolbox.Declarations;
using Toolbox.Docking.Client.Interfaces;
using Toolbox.Docking.Client.Plugins;
using Toolbox.Docking.Client.Services;

namespace Toolbox.Modules.MessageDomainExplainer
{
    [Export(AddinExamplesConsts.DummyDomainExplainer, typeof(ITbDomainVisualizer))]
    [PartCreationPolicy(CreationPolicy.NonShared)]
    public class DummyDomainExplainer : ITbDomainVisualizer
    {
        public static readonly Guid ExplainDomainActionGuid = new Guid("14a253ca-448e-4f8e-be7c-a15e1939b058");

        public async Task DisplayDomain(ITbObjectId qsarId, ITbUiState uiState, ITbClientServiceLocator clientServices)
        {
            var explainResult = await clientServices.ExtraActionService.ExecuteExtraAction
                (uiState, "Explain Domain with a message", qsarId.Guid, ExplainDomainActionGuid, 0, "");

            string domainMessage = "No domain explanation available.";
            
            clientServices.DialogService.ShowMessage(domainMessage, "Domain information");
        }
    }
}
