﻿using AddinExamplesGeneral;
using System;
using System.ComponentModel.Composition;
using System.Threading.Tasks;
using Toolbox.Declarations;
using Toolbox.Docking.Client.Interfaces;
using Toolbox.Docking.Client.Plugins;
using Toolbox.Docking.Client.Services;

namespace LMC.Toolbox.DummyCalcClientViews
{

    [Export(AddinExamplesConsts.ProfilerExplainer, typeof(ITbResultExplainer))]
    [PartCreationPolicy(CreationPolicy.NonShared)]
    public class DummyProfilerPlugin : ITbResultExplainer, ITbOptionsPlugin
    {
        public DummyProfilerPlugin()
        {
        }

        public Task Explain(ITbExplainData subject, ITbClientServiceLocator clientServices)
        {
            clientServices.DialogService.ShowMessage(
                "Dummy profiler result:" + Environment.NewLine + subject.TextToExplain, "Dummy profiler explain");
            return Task.FromResult("");
        }

        public Task<string> ExecuteOptions(ITbUiState uiState, ITbObjectId tbObjectId, string options,
            ITbClientServiceLocator clientServices)
        {
            clientServices.DialogService.ShowMessage(options, "Dummy profiler options");
            return Task.FromResult("");
        }
    }
}
