﻿using System;

namespace Toolbox.Docking.Api.Chemical
{
    /// <summary>
    /// Toolbox chemical type enumeration.
    /// </summary>
    [Serializable]
    public enum ChemicalType
    {
        //InputSubstanceType
        /// <summary>
        /// Unknown chemical type
        /// </summary>
        Unknown = 0,
        /// <summary>
        /// Chemical is defined as mono constituent
        /// </summary>
        MonoConstituent = 1,
        /// <summary>
        /// Chemical is defined as multi constituent
        /// </summary>
        MultiConstituent = 2,
        /// <summary>
        /// Chemical is a polymer
        /// </summary>
        Polymer = 3,
        /// <summary>
        /// Chemical is a UVCB
        /// </summary>
        Uvcb = 4,
        /// <summary>
        /// Chemical is a microorganism or toxin produced by a microorganism
        /// </summary>
        Microorganism = 5,

        /// <summary>
        /// system types, only objects generated from Toolbox server can have these
        /// </summary>
        MetaboliteSet = 100,
        /// <summary>
        ///  system types, only objects generated from Toolbox server can have these
        /// </summary>
        TautomericSet = 101,
        /// <summary>
        ///  system types, only objects generated from Toolbox server can have these
        /// </summary>
        Other = 255
    }
}