﻿using System.Collections.Generic;

namespace Toolbox.Docking.Api.Chemical
{
    /// <summary>
    /// Represent list of chemicals with caption and description
    /// Used as support for QSAR (ITbQsarFactory.AdditionalLists) or for specific QSAR prediction (ITbPrediction.SuportingChemicals)
    /// </summary>
    public interface ISuportingChemicals : IReadOnlyList<ChemicalWithData>
    {
        /// <summary>
        /// List caption - visible to the user
        /// </summary>
        string Caption { get; }

        /// <summary>
        /// Description of the list
        /// </summary>
        string Description { get; }
    }
}
