﻿namespace Toolbox.Docking.Api.Control
{
    /// <summary>
    /// Wrapper for CancellationToken 
    /// </summary>
    public interface ITbCancellationToken
    {
        /// <summary>
        /// Gets whether cancellation has been requested for this token
        /// </summary>
        bool IsCancellationRequested { get; }

        /// <summary>
        /// Throws a OperationCanceledException if this token has had cancellation requested.
        /// </summary>
        void ThrowIfCancellationRequested();
    }
}
