﻿using System;

namespace Toolbox.Docking.Api.Data
{
    /// <summary>
    /// Represents values qualifiers
    /// </summary>
    [Serializable]
    public enum TbDataQualifier
    {
        /// <summary>
        /// No qualifiers
        /// </summary>
        None = 0,
        /// <summary>
        /// Equal value qualifier
        /// </summary>
        Equal = 1,
        /// <summary>
        /// Less or equal value qualifier
        /// </summary>
        LessOrEqual = 3,
        /// <summary>
        /// Less value qualifier
        /// </summary>
        Lower = 4,
        /// <summary>
        /// Greater value qualifier
        /// </summary>
        Greater = 5,
        /// <summary>
        /// Greater or equal value qualifier
        /// </summary>
        GreaterOrEqual = 6,
        /// <summary>
        /// Not equal value qualifier
        /// </summary>
        NotEqual = 7,
        /// <summary>
        /// Circa value qualifier
        /// </summary>
        Circa = 8,
        /// <summary>
        /// Closed range qualifier
        /// </summary>
        ClosedRange = 10
    }
}