﻿using System;

namespace Toolbox.Docking.Api.Objects.Calculator
{
    /// <summary>
    /// Toolbox calculator's metadata flags.
    /// </summary>
    [Serializable]
    [Flags]
    public enum CalculatorFlags
    {
        /// <summary>
        /// Empty calculators flag.
        /// </summary>
        None = 0,

        /// <summary>
        /// The calculator returns pre-existing experimental data.
        /// </summary>
        ExperimentalData = 1,

        /// <summary>
        /// Calculator returns values based on a 3D structure of the molecule.
        /// </summary>
        Is3D = 2,

        /// <summary>
        /// Calculator  should be cached in Toolbox database.
        /// </summary>
        Cacheble = 4
    }
}