﻿using System.Collections.Generic;
using Toolbox.Docking.Api.ExtraActions;

namespace Toolbox.Docking.Api.Objects
{
    /// <summary>
    /// Factory, which objects have some additional functionalites.
    /// These will be displayed onto context menus for Toolbox objects,
    /// chemicals etc... 
    /// </summary>
    public interface ITbObjectFactoryExtraAction : ITbObjectFactory
    {
        /// <summary>
        /// Return the list of actions the provider implements. 
        /// </summary>
        /// <returns>
        /// List of <see cref="TbExtraActionDefinition"/> 
        /// </returns>
        IEnumerable<TbExtraActionDefinition> GetExtraActions();
    }
}
