﻿using System.Collections.Generic;
using Toolbox.Docking.Api.Relevancy;

namespace Toolbox.Docking.Api.Objects
{
    /// <summary>
    /// An interface which describes how relevant an object is for a given designation (enpoint location + metadata)
    /// </summary>
    public interface ITbObjectFactoryRelevant : ITbObjectFactory
    {
        /// <summary>
        /// A list of relevancies for different designations (endpoint locations + metadata)
        /// </summary>
        IEnumerable<TbDesignationRelevancy> Relevancies { get; }
    }
}
