﻿using System;

namespace Toolbox.Docking.Api.Objects.Profiler
{
    /// <summary>
    /// Toolbox profiler's metadata flags.
    /// </summary>
    [Serializable]
    [Flags]
    public enum ProfilerFlags
    {
        /// <summary>
        /// Empty prifiling flag.
        /// </summary>
        None = 0,

        /// <summary>
        /// Profiler returns only one category. Alternatively profiler may classify a chemical in many categories simultaneously
        /// </summary>
        IndependentCategories = 1,

        /// <summary>
        /// The categories are hierachically ordered
        /// </summary>
        HierarchicalCategories = 2,

        /// <summary>
        /// Profiler is decision tree scheme. Alternatively it have spearate logic for each category
        /// </summary>
        DecisionTree = 4,

        /// <summary>
        /// Categoris are sorted by specific order and shoud not be re-sorted by the system alphabetically.
        /// </summary>
        OrderedCategories = 8,

        /// <summary>
        /// The profiler can be used to store domain categories
        /// </summary>
        CanAddDomain = 16
    }
}
