﻿using System;
using Toolbox.Docking.Api.Units;

namespace Toolbox.Docking.Api.Objects.Qsar
{
    /// <summary>
    /// This class contains the most basic description for a QSAR descriptor.
    /// </summary>
    [Serializable]
    public sealed class QsarDescriptorInfo
    {
        /// <summary>
        /// The Toolbox object responsible for the calculation of the descriptor.
        /// </summary>
        public TbObjectId Descriptor { get; }

        /// <summary>
        /// The unit for the descriptor.
        /// </summary>
        public TbScale DescriptorUnit { get; }

        /// <summary>
        /// Constructor for the QsarDescriptorInfo object.
        /// </summary>
        /// <param name="descriptor">The Toolbox object responsible for the calculation of the descriptor.</param>
        /// <param name="descriptorUnit">The unit for the descriptor.</param>
        public QsarDescriptorInfo(TbObjectId descriptor, TbScale descriptorUnit)
        {
            Descriptor = descriptor;
            DescriptorUnit = descriptorUnit;
        }
    }
}