﻿using System;
using Toolbox.Docking.Api.Units;

namespace Toolbox.Docking.Api.Objects.Qsar
{
    /// <summary>
    /// This class contains the most basic description for a QSAR.
    /// </summary>
    [Serializable]
    public sealed class TbQsarInfo : TbObjectInfo
    {
        /// <summary>
        /// Constructor for the QSAR info object.
        /// </summary>
        /// <param name="objFlags">Object information flags</param>
        /// <param name="unit">The Unit the predictions of the QSAR are in.</param>
        public TbQsarInfo(TbObjectInfoFlags objFlags, TbUnit unit) : base(objFlags)
        {
            Unit = unit;
        }

        /// <summary>
        /// The Unit the predictions of the QSAR are in.
        /// </summary>
        public readonly TbUnit Unit;
    }
}