﻿using System;

namespace Toolbox.Docking.Api.Objects
{
    /// <summary>
    /// DomainStatus results
    /// </summary>
    [Serializable]
    public enum TbDomainStatus
    {
        /// <summary>
        /// The QSAR could not determine where the queried chemical falls in the QSAR domain
        /// </summary>
        Undefined,

        /// <summary>
        /// The QSAR has made a determination that the queried chemical cannot be assessed for a place within 
        /// the domain e.g. QSAR cannot deal with polymers. 
        /// </summary>
        NotApplicable,

        /// <summary>
        /// The chemical is OUT of the QSAR's domain
        /// </summary>
        OutOfDomain,

        /// <summary>
        /// The chemical is IN the QSAR's domain
        /// </summary>
        InDomain
    }
}