﻿using System;

namespace Toolbox.Docking.Api.Objects
{
    /// <summary>
    /// A class for providing additional information for <see cref="TbObjectAbout"/> in the form of label-value pairs.
    /// The label is the name (or title) of the piece of information and the value is the actual information
    /// </summary>
    [Serializable]
    public sealed class TbObjectAboutTextPair
    {
        private readonly string _label;
        private readonly string _value;

        /// <summary>
        /// Constructor of the model
        /// </summary>
        /// <param name="label">The label (or the name or title) of the actual information</param>
        /// <param name="value">The value or the actual information</param>
        public TbObjectAboutTextPair(string label, string value)
        {
            _label = label;
            _value = value;
        }

        /// <summary>
        /// The label (or the name or title) of the actual information
        /// </summary>
        public string Label => _label;
        /// <summary>
        /// The value or the actual information
        /// </summary>
        public string Value => _value;
    }
}
