﻿using System;

namespace Toolbox.Docking.Api.Objects
{
    /// <summary>
    /// Toolbox object's metadata flags
    /// </summary>
    [Flags]
    [Serializable]
    public enum TbObjectFlags
    {
        /// <summary>
        /// No specific flags
        /// </summary>
        None = 0,

        /// <summary>
        /// The object can work with mixtures.
        /// </summary>
        WorkWithMixtures = 1,

        /// <summary>
        /// The object can work with tautomeric sets.
        /// </summary>
        WorkWithTautomericSets = 2,

        /// <summary>
        /// The object is thread safe.
        /// </summary>
        IsThreadSafe = 4,
    }
}