﻿using System;

namespace Toolbox.Docking.Api.Objects
{
    /// <summary>
    /// Flags representing object's basic properties
    /// </summary>
    [Flags]
    [Serializable]
    public enum TbObjectInfoFlags
    {
        /// <summary>
        /// No any specific properties
        /// </summary>
        Empty = 0,

        /// <summary>
        /// The object has options (implements ITbObjectTunable)
        /// </summary>
        HasOptions = 1,

        /// <summary>
        /// The object has domain (implements ITbObjectDomain)
        /// </summary>
        HasDomain = 2
    }
}