﻿using System;
using System.Collections.Generic;
using Toolbox.Docking.Api.Data;

namespace Toolbox.Docking.Api.Relevancy
{
    /// <summary>
    /// This class represents how relevant an object is for a designation (enpoint location and metadata)
    /// </summary>
    [Serializable]
    public class TbDesignationRelevancy
    {
        /// <summary>
        /// Describes the level of relevancy
        /// </summary>
        public TbRelevancy Relevancy { get; }

        /// <summary>
        /// The endpoint location (rigid path) for which the relevancy is applicable
        /// </summary>
        public IReadOnlyList<string> MetadataLocation { get; }

        /// <summary>
        /// The metadata for which the relevancy is applicable
        /// </summary>
        public TbMetadata Metadata { get; }
    }
}
