﻿using System;
using System.Collections.Generic;

namespace Toolbox.Docking.Api.Units
{
    /// <summary>
    /// This class represents a Nominal type categorical scale.
    /// </summary>
    [Serializable]
    public sealed class TbNominalScale : TbQualitativeScale
    {
        /// <summary>
        /// Constructor for the Nominal type categorical scale. 
        /// </summary>
        /// <param name="name">Name for the scale.</param>
        /// <param name="familyGroup">Family group for the scale.</param>
        /// <param name="identity">The unique persistent identifier for the scale.</param>
        /// <param name="labels">The category members.</param>
        public TbNominalScale(string name, string familyGroup, Guid identity, IReadOnlyList<string> labels)
            : base(name, familyGroup, identity, labels)
        {
        }
    }
}
