﻿using System;
using System.Collections.Generic;

namespace Toolbox.Docking.Api.Units
{
    /// <summary>
    /// This class represents a Ordinal type categorical scale. 
    /// The order of the category members of an Ordinal, as opposed to Nominal, scale have significance.  
    /// </summary>
    [Serializable]
    public sealed class TbOrdinalScale : TbQualitativeScale
    {
        /// <summary>
        /// Constructor for the Ordinal type categorical scale. 
        /// </summary>
        /// <param name="name">Name for the scale.</param>
        /// <param name="familyGroup">Family group for the scale.</param>
        /// <param name="identity">The unique persistent identifier for the scale.</param>
        /// <param name="labels">The category members.</param>
        public TbOrdinalScale(string name, string familyGroup, Guid identity, IReadOnlyList<string> labels)
            : base(name, familyGroup, identity, labels)
        {
        }
    }
}
