﻿using System;

namespace Toolbox.Docking.Api.Units
{
    /// <summary>
    /// Data unit representation.
    /// </summary>
    [Serializable]
    public sealed class TbUnit
    {
        /// <summary>
        /// Constructor for a Toolbox unit object.
        /// </summary>
        /// <param name="familyName">
        /// The family name for the unit e.g. <b>Mass</b>.
        /// </param>
        /// <param name="unit">
        /// The unit name e.g. <b>kg</b>.
        /// </param>
        public TbUnit(string familyName, string unit)
        {
            FamilyName = familyName;
            Unit = unit;
        }

        /// <summary>
        /// The name of the Family the unit belongs to.
        /// </summary>
        public string FamilyName { get; }

        /// <summary>
        /// The name of the Toolbox unit.
        /// </summary>
        public string Unit { get; }
    }
}